@echo off
rem this file is the batch wrapper to be invoked by the RawContainer buildFrameworkCommand like
rem in the project properties CPP_CG (or C_CG) the original buildFrameworkCommand for the chosen compiler (e.g.Cygwin) look like
rem   "$OMROOT/etc/Executer.exe"  "\"\"$OMROOT\"\etc\cygwinmake.bat cygwinbuild.mak build .....
rem it must be modified as follow when instrumentation (TestRealTime stereotype) is selected
rem "\"$OMROOT/etc/Executer.exe\" \"\\\"$OMROOT\\etc\\testrtf.bat\\\" cygwinmake cygwinbuild.mak build ......
rem it must be located in the C:\Program Files\Telelogic\Rhapsody x.y\Share\etc
echo current directory: %CD%
rem get settings from Rhapsody UI
RhapConf.exe -result > RhapConf.pl

set RHAPSODYSHAREETC=%0
set RHAPSODYSHAREETC=%RHAPSODYSHAREETC:\TestRT.bat=%
set RHAPSODYSHAREETC=%RHAPSODYSHAREETC:"=%
set OMROOT=%RHAPSODYSHAREETC:\etc=%
rem echo %OMROOT%
set optFileName=%1.opt

if "%2"=="" set target=all
if "%2"=="build" set target=all
if "%2"=="rebuild" set target=clean all
if "%2"=="clean" set target=clean
set MAKEFLAGS=

rem generate the local TestRT.bat for compiler/linker and ATLTGT sets
rem then generate the option file
rem then check that appropriate batch file has enough %x on the make command line
RhapTestRT.exe -bat "%optFileName%" "%RHAPSODYSHAREETC%\Env2TDP.txt" %1
CALL TestRT.bat

echo compiler %CC% and %CPP% for C++, linker %LINK_CMD%
echo ATLTGT=%ATLTGT%
rem invoke the appropriate batch file found in the Env2TDP.txt file (BATCH=xxx)
if ("%BATCH_CMD%" == "") goto localmake
if not ("%RTRTMEMPRO%" == "True") goto NoInstrum
"%RHAPSODYSHAREETC%\%BATCH_CMD%" %* "LINK_CMD=attolcc -opt=%optFileName% -- %LINK_CMD%" "CC=attolcc -opt=%optFileName% -- %CC%" "CPP=attolcc -opt=%optFileName% -- %CPP%"
goto end
:NoInstrum
"%RHAPSODYSHAREETC%\%BATCH_CMD%" %*
goto end

localmake:
if("%1" == "cygwinbuild.mak") goto cygwinbuild
if("%1" == "msvcbuild.mak") goto msvcbuild
if("%1" == "qnxcwbuild.mak") goto qnxcwbuild
echo No Build batch found!!! update %RHAPSODYSHAREETC%\Env2TDP.txt to add BATCH=xxx.bat or update TestRT.bat to add the make invocation for %1"
exit /b 1
cygwinbuild:
make %target% -f %1 %3 %4 %5 %6 %7 %8 %9 OM_GCC_VER="-4" "%CC_VAR%=attolcc -opt=%optFileName% -- %CC%" "%CPP_VAR%=attolcc -opt=%optFileName% -- %CPP%" "%LINK_CMD_VAR%=attolcc -opt=%optFileName% -- %LINK_CMD%"
goto end

qnxcwbuild:
set QNXROOT=C:/QNX650
set MAKEFLAGS=-I%QNXROOT%/target/qnx6/usr/include
set QNX_TARGET=%QNXROOT%/target/qnx6
set QNX_HOST=%QNXROOT%/host/win32/x86
set QCC_CONF_PATH=%QNX_HOST%/etc/qcc
set LD_LIBRARY_PATH=%QNXROOT%/target/qnx6/lib
set PATH=%QNXROOT%/host/win32/x86/usr/bin;%PATH%

make -s %target% -f %1 %3 %4 %5 %6 %7 %8 %9 "%CC_VAR%=attolcc -opt=%optFileName% -- %CC%" "%CPP_VAR%=attolcc -opt=%optFileName% -- %CPP%" "%LINK_CMD_VAR%=attolcc -opt=%optFileName% -- %LINK_CMD%"
goto end

msvcbuild:
if "%4"=="VC9" set VS_PATH=C:\Program Files (x86)\Microsoft Visual Studio 9.0\
if "%4"=="VC10" set VS_PATH=%VS_2010_PATH%
if "%4"=="VC11" set VS_PATH=%VS_2012_PATH%
if "%4"=="VC12" set VS_PATH=%VS_2013_PATH%

if EXIST  "%VS_PATH%" goto :continueExecution

@echo Value of the property MSVC::IDEVersion corresponds to the version of Visual Studio.
@echo VC9 - Visual Studio 2008
@echo VC10 - Visual Studio 2010
@echo VC11 - Visual Studio 2012
@echo VC12 - Visual Studio 2013
@echo Current value is "%4", but no Visual Studio installation was found in the directory "%VS_PATH%".

exit /b 1

:continueExecution
if "%3"=="x86" goto :x86set
call "%VS_PATH%\VC\VcVarsall.bat" %3
goto :doMake
:x86set
call "%VS_PATH%\VC\bin\VcVars32.bat" x86
:doMake
echo ``nmake.exe
nmake /nologo /S /F %1 %target% MS_VER="%4" %5 %6 %7 %8 %9 "%CC_VAR%=attolcc -opt=%optFileName% -- %CC%" "%CPP_VAR%=attolcc -opt=%optFileName% -- %CPP%" "%LINK_CMD_VAR%=attolcc -opt=%optFileName% -- %LINK_CMD%"

goto end

rem User additional make invocation here after

end:

